# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`dovecot`](#dovecot): This class installs and cofigures dovecot  Parameters:
* [`dovecot::install`](#dovecot--install): This class installs dovecot packages   Will install current versions of dovecot-core,dovecot-imapd and dovecot-pop3d
* [`dovecot::service`](#dovecot--service): manage dovecot service

### Defined types

* [`dovecot::config`](#dovecot--config): Internal define to handle configuration content
* [`dovecot::configfile`](#dovecot--configfile): Internal define to create a configuration file and include it in the main config file

## Classes

### <a name="dovecot"></a>`dovecot`

This class installs and cofigures dovecot

Parameters:

#### Parameters

The following parameters are available in the `dovecot` class:

* [`main_config`](#-dovecot--main_config)
* [`configs`](#-dovecot--configs)
* [`main_config_file`](#-dovecot--main_config_file)
* [`config_path`](#-dovecot--config_path)
* [`local_configdir`](#-dovecot--local_configdir)
* [`owner`](#-dovecot--owner)
* [`group`](#-dovecot--group)
* [`mode`](#-dovecot--mode)
* [`include_sysdefault`](#-dovecot--include_sysdefault)
* [`create_resources`](#-dovecot--create_resources)

##### <a name="-dovecot--main_config"></a>`main_config`

Data type: `Hash`

Hash of configurations to include in the main
configuration file.
Defaults to {}

Default value: `{}`

##### <a name="-dovecot--configs"></a>`configs`

Data type: `Hash`

Hash of configs to write
Defaults to {}

Default value: `{}`

##### <a name="-dovecot--main_config_file"></a>`main_config_file`

Data type: `String`

the name of the main configuration file

Default value: `'dovecot.conf'`

##### <a name="-dovecot--config_path"></a>`config_path`

Data type: `String`

the path where the configuration is.

Default value: `'/etc/dovecot'`

##### <a name="-dovecot--local_configdir"></a>`local_configdir`

Data type: `String`

the name of a directory to put local
configuration files

Default value: `'conf.d'`

##### <a name="-dovecot--owner"></a>`owner`

Data type: `String`

owner of the configuration files

Default value: `'root'`

##### <a name="-dovecot--group"></a>`group`

Data type: `String`

group of the configuration files

Default value: `'root'`

##### <a name="-dovecot--mode"></a>`mode`

Data type: `String`

mode of the configuration files

Default value: `'0644'`

##### <a name="-dovecot--include_sysdefault"></a>`include_sysdefault`

Data type: `Boolean`

= true,
if true (the default) an include statement
in the main configuration file is added to
include the system defaults before the local
configuration.

Default value: `true`

##### <a name="-dovecot--create_resources"></a>`create_resources`

Data type: `Hash`

a Hash of Hashes to create additional resources eg. to
retrieve a certificate.
Defaults to {} (do not create any additional resources)
Example (hiera):

dovecot::create_resources:
    sslcert::get_cert:
        get_my_dovecot_cert:
          private_key_path: '/etc/dovecot/ssl/key.pem'
          cert_path: '/etc/dovecot/ssl/cert.pem'

Will result in  executing:

sslcert::get_cert{'get_my_postfix_cert':
  private_key_path => "/etc/dovecot/ssl/key.pem"
  cert_path        => "/etc/dovecot/ssl/cert.pem"
}

Default value: `{}`

### <a name="dovecot--install"></a>`dovecot::install`

This class installs dovecot packages

 Will install current versions of dovecot-core,dovecot-imapd and dovecot-pop3d

#### Parameters

The following parameters are available in the `dovecot::install` class:

* [`packages`](#-dovecot--install--packages)
* [`package_ensure`](#-dovecot--install--package_ensure)

##### <a name="-dovecot--install--packages"></a>`packages`

Data type: `Array`

Array of packages to install
Example (hiera):
  dovecot::install::packages:
    - dovecot-core
    - dovecot-imapd
    - dovecot-pop3d

Default value: `['dovecot-core']`

##### <a name="-dovecot--install--package_ensure"></a>`package_ensure`

Data type: `String`

what to ensure for package
Defaults to 'installed'

Default value: `'installed'`

### <a name="dovecot--service"></a>`dovecot::service`

manage dovecot service

#### Parameters

The following parameters are available in the `dovecot::service` class:

* [`ensure`](#-dovecot--service--ensure)
* [`enable`](#-dovecot--service--enable)
* [`service_name`](#-dovecot--service--service_name)

##### <a name="-dovecot--service--ensure"></a>`ensure`

Data type: `String`

Whether a service should be running.
Defaults to 'running'

Default value: `'running'`

##### <a name="-dovecot--service--enable"></a>`enable`

Data type: `Boolean`

Whether a service should be enabled.
Defaults to true

Default value: `true`

##### <a name="-dovecot--service--service_name"></a>`service_name`

Data type: `String`

The name of the service

Default value: `'dovecot'`

## Defined types

### <a name="dovecot--config"></a>`dovecot::config`

Internal define to handle configuration content

#### Parameters

The following parameters are available in the `dovecot::config` defined type:

* [`file`](#-dovecot--config--file)
* [`recursion`](#-dovecot--config--recursion)
* [`trim`](#-dovecot--config--trim)
* [`values`](#-dovecot--config--values)
* [`sections`](#-dovecot--config--sections)

##### <a name="-dovecot--config--file"></a>`file`

Data type: `String`

the name (including path) of the configuration file
Defaults to $title

Default value: `$title`

##### <a name="-dovecot--config--recursion"></a>`recursion`

Data type: `String`

String to identify the recursion for the sections
For details see code ;(
Defaults to '0'

Default value: `'0'`

##### <a name="-dovecot--config--trim"></a>`trim`

Data type: `Integer`

integer which gives the amount of spaces used to
ident any configuration added in this iteration of the
recursion. Defauls to 0

Default value: `0`

##### <a name="-dovecot--config--values"></a>`values`

Data type: `Hash`

The hash it expects needs name which corresponds to the $filename saved in $config_path/$local_configdir/
For instance the following hash will produce a file in /etc/dovecot/conf.d/master.conf if $config_path
and $local_configdir are set to default.
**NOTE - the file named will be completely overwritten, so ensure that ALL needed values are specified.**

```
dovecot::config:
  'master.conf':                     # <- name ($filename)
    values:
      default_process_limit: 350
      default_vsz_limit: 1024M
      default_client_limit: 2000
```

The resulting **/etc/dovecot/conf.d/master.conf** will look like this:

```
This file is managed by Puppet. DO NOT EDIT.
default_client_limit = 2000
default_process_limit = 350
default_vsz_limit = 1024M
```

Defaults to {}

Default value: `{}`

##### <a name="-dovecot--config--sections"></a>`sections`

Data type: `Array[Hash]`

Sometimes you need to have [Sections](https://doc.dovecot.org/configuration_manual/config_file/#sections)
in your config files.
These are defined as an Array of hashes similar to the intial config hash:
Expanding on our previous example, wanting to add a section we can add a 'sections' key to our hash.

```
dovecot::config:
  mail.conf:
    values:
      'mail_location': 'maildir:~/'
    sections:
      - name: 'namespace inbox'
        values:
          'inbox': 'yes'
          'seperator': '.'
          'prefix': 'INBOX'
```

This will result in **/etc/dovecot/conf.d/mail.conf** containing the following:

```
This file is managed by Puppet. DO NOT EDIT.
mail_location = maildir:~/
namespace inbox {
  inbox = yes
  separator =.
  prefix =INBOX.
}
```

Some dovecot sections have a double bracket system (section within a section). This is done as follows:

Example (hiera):

```
dovecot::config:
  master.conf:
    values:
      default_process_limit: 350
      default_vsz_limit: 1024M
      default_client_limit: 2100
    sections:
      - name: 'service imap-login'
        sections:
          - name: 'inet_listener imap'
            values:
              'port': '143'
          - name: inet_listener imaps
            values:
              'port': '993'
              'ssl': 'yes'
          - name: 'inet_listener pop3'
            values:
              'port': '110'
          - name: inet_listener pop3s
            values:
              'port': '995'
              'ssl': 'yes'
```
This will produce the file **/etc/dovecot/conf.d/master.conf** with content below:

```
This file is managed by Puppet. DO NOT EDIT.
default_client_limit = 2100
default_process_limit = 350
default_vsz_limit = 1024M
service imap-login {

  inet_listener imap {
    port = 143
  }
  inet_listener imaps {
    port = 993
    ssl = yes
  }
}
service pop3-login {

  inet_listener pop3 {
    port = 110
  }
  inet_listener pop3s {
    port = 995
    ssl = yes
  }
}
```

Defaults to []

Default value: `[]`

### <a name="dovecot--configfile"></a>`dovecot::configfile`

Internal define to create a configuration file
and include it in the main config file

#### Parameters

The following parameters are available in the `dovecot::configfile` defined type:

* [`path`](#-dovecot--configfile--path)
* [`owner`](#-dovecot--configfile--owner)
* [`group`](#-dovecot--configfile--group)
* [`mode`](#-dovecot--configfile--mode)
* [`local_configdir`](#-dovecot--configfile--local_configdir)
* [`include_in`](#-dovecot--configfile--include_in)
* [`filename`](#-dovecot--configfile--filename)
* [`values`](#-dovecot--configfile--values)
* [`sections`](#-dovecot--configfile--sections)

##### <a name="-dovecot--configfile--path"></a>`path`

Data type: `String`

path to the configuration file

##### <a name="-dovecot--configfile--owner"></a>`owner`

Data type: `String`

owner of the configuration file

##### <a name="-dovecot--configfile--group"></a>`group`

Data type: `String`

group of the configuration file

##### <a name="-dovecot--configfile--mode"></a>`mode`

Data type: `String`

mode of the configuration file

##### <a name="-dovecot--configfile--local_configdir"></a>`local_configdir`

Data type: `String`

directory name where the local configuration is
only used if $include_in is not set to ''

##### <a name="-dovecot--configfile--include_in"></a>`include_in`

Data type: `Optional[String[1]]`

filename to add an include statement for the configuration
file. Default unset which disables this function

Default value: `undef`

##### <a name="-dovecot--configfile--filename"></a>`filename`

Data type: `String`

the name of the configuration file
Defaults to $title

Default value: `$title`

##### <a name="-dovecot--configfile--values"></a>`values`

Data type: `Hash`

Hash of configuration parameters to include in $filename
Defaults to {}
see previous [`values`](#values_example) example

Default value: `{}`

##### <a name="-dovecot--configfile--sections"></a>`sections`

Data type: `Array[Hash]`

Array of configuration section to include in $filenmame
Defaults to []
see previous [`sections`](#sections_example) example

Default value: `[]`

